<template>
  <div id="d3-alert-type-legend" />
</template>
<script>
/* eslint-disable @typescript-eslint/no-this-alias,
  no-param-reassign, camelcase, no-return-assign, no-plusplus
*/
import Vue from 'vue';
import * as d3 from 'd3';
import * as charts from '@/vis/chartTyped';

export default Vue.extend({
  props: {
    locus: {
      type: Object,
      default: () => ({}),
    },
    alerts: {
      type: Array,
      default: () => [],
    },
  },
  data() {
    return {
      chart: {
        width: 750,
        height: 30,
        marginTop: 0, // note: this is not used currently
        marginBottom: 10,
        marginLeft: 50,
        marginRight: 10, // note: this is not used currently
      },
      dataGroup: null,
      nearbyLoci: [],
    };
  },
  watch: {
    alerts() {
      // FIXME alertMap is built multiple times throughout the components. Fix this!
      this.alertMap = new Map();
      this.alerts.forEach((alert) => {
        this.alertMap.set(alert.id, alert);
      });
      // this.plot();
      this.makeLegends();
    },
  },
  mounted() {
    this.d3Objects = {};
    const svg = d3
      .select('#d3-alert-type-legend')
      .append('svg')
      .attr('width', this.chart.width)
      .attr('height', this.chart.height)
      .append('g')
      .attr('transform', `translate(${this.chart.marginLeft}, ${this.chart.marginBottom})`);
    charts.chartStore.commit('predicate', {
      group: 'default',
      chartName: 'alert-type',
      predicate: null,
    });
    this.d3Objects.svg = svg;
  },
  methods: {
    makeLegends() {
      let selectedPassband = null;
      let selectedAlertType = null;
      let selectedRcid = null;
      const that = this;

      function selectionPredicate(d) {
        const passbandValue = d.payload.ant_passband;
        const alertTypeValue = d.type;
        const alert = that.alertMap.get(d.payload.alert_id);

        // if we're selecting on an rcid but this mark lacks rcid information, filter it out.
        if (!alert && selectedRcid) {
          return false;
        }

        const alertRcidValue = alert && alert.properties.ztf_rcid;
        return (
          (!selectedPassband || passbandValue === selectedPassband)
            && (!selectedAlertType || alertTypeValue === selectedAlertType)
            && (!selectedRcid || alertRcidValue === selectedRcid)
        );
      }

      charts.chartStore.commit('predicate', {
        group: 'default',
        chartName: 'alert-type',
        predicate: selectionPredicate,
      });

      const markScale = charts.alertTypeMarkScale();
      const passbandScale = charts.passbandScale();
      const rcidScale = charts.rcidScale();

      const circleSize = 6;
      const { locus } = this;

      let currentOffset = 0;

      function makeLegendText(text, offset) {
        offset = offset || 0;
        return that.d3Objects.svg
          .append('g')
          .append('text')
          .attr('transform', `translate(${currentOffset + offset}, ${circleSize})`)
          .attr('dominant-baseline', 'middle')
          .text(`${text}:`);
      }

      function rcid_set() {
        const rcids = new Set();
        that.alerts.forEach((alert) => {
          const rcid = alert.properties.ztf_rcid;
          if (rcid !== undefined) {
            rcids.add(rcid);
          }
        });
        return Array.from(rcids);
      }

      function createPassBandLegend() {
        const passbandGroups = that.d3Objects.svg.append('g')
          .attr('transform', `translate(${currentOffset}, 0)`)
          .selectAll('g')
          .data(['g', 'R'])
          .enter()
          .append('g');

        // This is relatively ugly, but we're using it
        // to setup a callback in LocusPlotLightcurve
        const legendText = makeLegendText('passband', -45);
        if (rcid_set().length > 1) {
          legendText
            .attr('id', 'alert-legend-passband-text')
            .style('cursor', 'pointer');
        }

        passbandGroups
          .style('cursor', 'pointer')
          .attr('transform', (d, i) => `translate(${35 + i * 30}, 0)`)
          .on('click', (event, passband) => {
            if (passband === selectedPassband) {
              selectedPassband = null; // unselect
            } else {
              selectedPassband = passband; // select
            }

            // update legend opacity to indicate selection
            passbandGroups.attr('opacity', (d) => {
              if (selectedPassband === null || selectedPassband === d) {
                return 'null';
              }
              return '0.3';
            });
            charts.triggerRedraw('default');
          });

        passbandGroups
          .append('circle')
          .attr('r', circleSize)
          .attr('cx', circleSize)
          .attr('cy', circleSize)
          .attr('fill', (d) => passbandScale(d));

        passbandGroups
          .append('text')
          .text((d) => d)
          .attr('transform', `translate(${circleSize * 2 + 2}, ${circleSize})`)
          .attr('dominant-baseline', 'middle');

        currentOffset += 35 + 90;
      }

      function createRcidLegend() {
        const rcidList = rcid_set();
        if (rcidList.length < 2) {
          return;
        }
        rcidList.sort((a, b) => a - b);
        // enforce the ordering in the scale range() by calling it in order
        rcidList.forEach((e) => rcidScale(e));

        makeLegendText('rcid')
          .attr('id', 'alert-legend-rcid-text')
          .style('cursor', 'pointer');

        const rcidGroups = that.d3Objects.svg
          .append('g')
          .attr('transform', `translate(${currentOffset + 35}, 0)`)
          .selectAll('g')
          .data(rcidList)
          .enter()
          .append('g');

        rcidGroups
          .style('cursor', 'pointer')
          .attr('transform', (d, i) => `translate(${i * 40}, 0)`)
          .on('click', (event, rcid) => {
            if (selectedRcid === rcid) {
              selectedRcid = null;
            } else {
              selectedRcid = rcid;
            }
            // update legend opacity to indicate selection
            rcidGroups.attr('opacity', (d) => {
              if (selectedRcid === null || selectedRcid === d) {
                return 'null';
              }
              return '0.3';
            });

            charts.triggerRedraw('default');
          });

        rcidGroups
          .append('circle')
          .attr('r', circleSize)
          .attr('cx', circleSize)
          .attr('cy', circleSize)
          .attr('fill', (d) => rcidScale(d));

        rcidGroups
          .append('text')
          .text((d) => d)
          .attr('transform', `translate(${circleSize * 2 + 2}, ${circleSize})`)
          .attr('dominant-baseline', 'middle');

        currentOffset += 70 + rcidList.length * 40;
      }

      function createAlertTypesLegend() {
        const counts = {};
        charts.alertTypes.forEach((t) => (counts[t] = 0));
        locus.lightcurve.forEach((a) => {
          if (a.frontend_mag_type.endsWith('_maglim')) {
            counts.ulim++;
            counts.llim++;
          }
          if (a.frontend_mag_type === 'ERROR_OTHER') {
            counts.ERROR_OTHER++;
          } else {
            counts.mag++;
          }
        });

        const existingTypes = charts.alertTypes.filter((d) => counts[d] > 0);

        makeLegendText('type');

        const alertTypeGroups = that.d3Objects.svg
          .append('g')
          .attr('transform', `translate(${currentOffset + 45}, 0)`)
          .selectAll('g')
          .data(existingTypes)
          .enter()
          .append('g');

        alertTypeGroups.style('cursor', 'pointer').on('click', (event, alertType) => {
          if (alertType === selectedAlertType) {
            selectedAlertType = null; // unselect
          } else {
            selectedAlertType = alertType; // select
          }

          // update legend opacity to indicate selection
          alertTypeGroups.attr('opacity', (d) => {
            if (selectedAlertType === null || selectedAlertType === d) {
              return 'null';
            }
            return '0.3';
          });

          charts.triggerRedraw('default');
        });

        alertTypeGroups
          .append('path')
          .attr('d', (d) => markScale(d))
          .attr(
            'transform',
            (d, i) => `translate(${50 * i}, ${circleSize})`,
          )
          .attr('fill', 'black')
          .attr('stroke', 'black');

        alertTypeGroups
          .append('text')
          .attr('transform', (d, i) => `translate(${50 * i + circleSize}, ${circleSize})`)
          .attr('dominant-baseline', 'middle')
          .text((d) => {
            switch (d) {
              case 'ulim': return 'ulim';
              case 'llim': return 'llim';
              case 'raw':
              case 'mag':
              case 'calibrated':
                return 'mag';
              default: return 'error';
            }
          });
      }

      createPassBandLegend();
      createRcidLegend();
      createAlertTypesLegend();
    },
  },
});
</script>
